Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.tapestry5.corelib.components
Class Tree

    java.lang.Object
      org.apache.tapestry5.corelib.components.Tree

    @Events(value={"nodeSelected","nodeUnselected"})
    public class Tree

extends java.lang.Object

A component used to render a recursive tree structure, with expandable/collapsable/selectable nodes. The data that is displayed by the component is provided as a `TreeModel`. A secondary model, the `TreeExpansionModel`, is used to track which nodes have been expanded. The optional `TreeSelectionModel` is used to track node selections (as currently implemented, only leaf nodes may be selected).

The Tree component uses special tricks to support recursive rendering of the Tree as necessary.

Since:
  5.3

Component Parameters
Name | Description | Type | Flags | Default | Default Prefix | Since
--- | --- | --- | --- | --- | --- | ---
class | Allows the container to specify additional CSS class names for the outer DIV element. The outer DIV always has the class name "t-tree-container"; the additional class names are typically used to apply a specific size and width to the component. | String |  |  | literal |
expansionModel | Used to control the Tree's expansion model. By default, a persistent field inside the Tree component stores a org.apache.tapestry5.tree.DefaultTreeExpansionModel. This parameter may be bound when more control over the implementation of the expansion model, or how it is stored, is required. | org.apache.tapestry5.tree.TreeExpansionModel | Not Null | defaultTreeExpansionModel | prop |
label | A renderable (usually a org.apache.tapestry5.Block) that can render the label for a tree node. This will be invoked after the org.apache.tapestry5.corelib.components.Tree#value parameter has been updated. | org.apache.tapestry5.runtime.RenderCommand |  | block:defaultRenderTreeNodeLabel | prop |
model | The model that drives the tree, determining top level nodes and making revealing the overall structure of the tree. | org.apache.tapestry5.tree.TreeModel | Required |  | prop |
node | Optional parameter used to inform the container about what TreeNode is currently rendering; this is primarily used when the label parameter is bound. | org.apache.tapestry5.tree.TreeNode |  |  | prop |
selectionModel | Used to control the Tree's selections. When this parameter is bound, then the client-side Tree will track what is selected or not selected, and communicate this (via Ajax requests) up to the server, where it will be recorded into the model. On the client-side, the Tree component will add or remove the CSS class from for the node. | org.apache.tapestry5.tree.TreeSelectionModel |  |  | prop |
value | Optional parameter used to inform the container about the value of the currently rendering TreeNode; this is often preferable to the TreeNode, and like the node parameter, is primarily used when the label parameter it bound. | Object |  |  | prop |

Events:

nodeSelected
nodeUnselected

Constructor Summary
`Tree()`

Method Summary
`void` | `clearExpansions()` Clears the tree's `TreeExpansionModel`.
`java.lang.String` | `getContainerClass()`
`TreeExpansionModel` | `getDefaultTreeExpansionModel()`
`TreeExpansionModel` | `getExpansionModel()` Returns the actual `TreeExpansionModel` in use for this Tree component, as per the expansionModel parameter.
`java.lang.Object` | `getRenderRootNodes()`
`TreeSelectionModel` | `getSelectionModel()` Returns the actual `TreeSelectionModel` in use for this Tree component, as per the `selectionModel` parameter.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Tree

    public Tree()

Method Detail

### getContainerClass

    public java.lang.String getContainerClass()

### getDefaultTreeExpansionModel

    public TreeExpansionModel getDefaultTreeExpansionModel()

### getExpansionModel

    public TreeExpansionModel getExpansionModel()

  Returns the actual `TreeExpansionModel` in use for this Tree component, as per the expansionModel parameter. This is often, but not always, the same as `getDefaultTreeExpansionModel()`.

### getSelectionModel

    public TreeSelectionModel getSelectionModel()

  Returns the actual `TreeSelectionModel` in use for this Tree component, as per the `selectionModel` parameter.

### getRenderRootNodes

    public java.lang.Object getRenderRootNodes()

### clearExpansions

    public void clearExpansions()

  Clears the tree's `TreeExpansionModel`.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2012 The Apache Software Foundation.